
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#ifndef _WIN32
  #include  <unistd.h>
#endif  

#include  "gromada/file.h"


FHandle  *f_open (
  const char  *filename,
  int         accessMode)
{
  FHandle  *fh;

  fh = (FHandle *) malloc (sizeof(FHandle));
  memset (fh, 0, sizeof(FHandle));
#ifdef  _WIN32
  fh->handle = open (filename, accessMode, 0666);
#else
  fh->handle = open64 (filename, accessMode, 0666);
#endif
  if (fh->handle == 0) {
    free (fh);
    fh = NULL;
  }
  else {
    fh->accessMode = accessMode;
    strncpy (fh->filename, (filename), PATH_MAX);
  }
  return (fh);
}


int  f_read (
  FHandle  *fh,
  Pointer  buffer,
  Uint     sizeBytes)
{
  return (read (fh->handle, buffer, sizeBytes));
}


int  f_write (
  FHandle  *fh,
  Pointer  buffer,
  Uint     sizeBytes)
{
  return (write (fh->handle, buffer, sizeBytes));
}


int  f_seek (
  FHandle  *fh,
  Int64    offset,
  int      whence)
{
#ifdef  _WIN32
  return (_lseeki64 (fh->handle, offset, whence) != offset && whence == SEEK_SET ? FALSE : TRUE);
#else
  return (lseek64 (fh->handle, offset, whence) != offset && whence == SEEK_SET ? FALSE : TRUE);
#endif
}


Int64  f_tell (
  FHandle  *fh)
{
#ifdef  _WIN32
  return (_telli64 (fh->handle));
#else
  return (lseek64 (fh->handle, 0, SEEK_CUR));
#endif
}


void  f_close (
  FHandle  *fh)
{
  if (fh) {
    if (fh->handle)
      close (fh->handle);
    free (fh);
  }
}

